// MixWCallbookMfc.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "MixWCallbookMfc.h"

#include <atlbase.h>
#include <process.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


//---------------------------------------------------------------------------

// Variables to exchange data between 
// LookupCall function and callbook thread

CComBSTR bsPath;
CComBSTR bsCallSign;

CComBSTR bsInfo;

volatile int iSearchResult = 0;

// Variables needed to synchronize threads

volatile BOOL bExitThread = FALSE;
volatile BOOL bDoLookup = FALSE;

// ActiveX variables

COleDispatchDriver m_DispDrv; // Dispatch driver
DISPID dispidLookupCall; // Lookup function ID


/////////////////////////////////////////////////////////////////////////////
// CMixWCallbookMfcApp

BEGIN_MESSAGE_MAP(CMixWCallbookMfcApp, CWinApp)
	//{{AFX_MSG_MAP(CMixWCallbookMfcApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMixWCallbookMfcApp construction

CMixWCallbookMfcApp::CMixWCallbookMfcApp()
{
	TRACE("CMixWCallbookMfcApp Constructor\n");
}

CMixWCallbookMfcApp::~CMixWCallbookMfcApp()
{
	TRACE("CMixWCallbookMfcApp Destructor\n");
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CMixWCallbookMfcApp object

CMixWCallbookMfcApp theApp;

BOOL CMixWCallbookMfcApp::InitInstance() 
{
	TRACE("CMixWCallbookMfcApp InitInstance\n");
	
	BOOL rc = CWinApp::InitInstance();

	int rc1 = _beginthread((void (__cdecl *)(void *))CallBookThreadStarter, 0, this);
	TRACE("_beginthread: %i\n", rc1);

//	AfxBeginThread(CallBookThreadStarter, this, THREAD_PRIORITY_LOWEST/*,0, CREATE_SUSPENDED */);

	return rc;
}

/////////////////////////////////////////////////////////////////////////////

int CMixWCallbookMfcApp::ExitInstance() 
{
	TRACE("CMixWCallbookMfcApp ExitInstance\n");

	bExitThread = TRUE;
	while(bExitThread) Sleep(100);  // Wait while it unloads VB DLL

	return CWinApp::ExitInstance();
}

//---------------------------------------------------------------------------

// Initialize VB ActiveX DLL

void CMixWCallbookMfcApp::PrepareActiveX()
{
	int rc = CoInitialize(NULL); // Initialize COM
	TRACE ("CoInitialize: %i\n", rc);

	// Create dispatch driver

	m_DispDrv.m_lpDispatch = 0;

	// Loads ActiveX DLL automatically
	int rc1 = m_DispDrv.CreateDispatch("MixActiveXCallBook.MixActiveXCb");

	if (rc1 == 0)
	{
		TRACE("Cannot get dispatch!\n");
	}
	else
	{
		TRACE("Get dispatch is OK\n");
	}

	// Get DISPID of LookupCall function

	OLECHAR* lpszLookupCall = L"LookupCall"; 
	
	int rc2 = m_DispDrv.m_lpDispatch->GetIDsOfNames( IID_NULL, &lpszLookupCall, 1, 
							  LOCALE_SYSTEM_DEFAULT, &dispidLookupCall );

	TRACE("GetIDsOfNames: %i\n", rc2);
}

//---------------------------------------------------------------------------

// Uninitialize VB ActiveX DLL

void CMixWCallbookMfcApp::UnprepareActiveX()
{
	m_DispDrv.ReleaseDispatch(); // Unloads ActiveX DLL automatically
}

//---------------------------------------------------------------------------

//
// Function LookupCall is called by MixW to find a record for the specified callsign
//
// Parameters:
//		sPath	- database path (pathname) entered in Callbook Settings dialog
//		sCall	- callsign to look for
//		sBuffer - memory buffer that MixW gives to copy the record to
//		iBufLen - length of this buffer (10000 bytes)
//

// Return values

#define MCB_FOUND           0		// Callsign is found, record is copied
#define MCB_NOT_FOUND	    1		// Callsign is not found
#define MCB_NO_DATABASE     2		// Bad path or database does not exist
#define MCB_DATABASE_ERROR  3		// Other database error

// Each returned record should consist of 0 or more fields,
// A field constcts of 
//		#1				1 byte
//		field code		1 byte
//		data			0 or more bytes of ASCII string

_declspec(dllexport) int LookupCall(const char* sPath, const char* sCall,
									char* sBuffer, int iBufLen)
{
	TRACE("LookupCall\n");

	bsPath = sPath;
	bsCallSign = sCall;

	iSearchResult = MCB_DATABASE_ERROR;

	bDoLookup = TRUE;	
	while(bDoLookup)
		Sleep(100);	// Wait


	if (iSearchResult==0) // Found, copy data
	{
		CString sInfo = bsInfo;

		int iStrLen = sInfo.GetLength();

		if (iStrLen+1 > iBufLen) // notice ending '\0'
		{
			return MCB_DATABASE_ERROR;	// Info is too long
		}

		memcpy(sBuffer, sInfo, iStrLen+1); // Close with '\0'

	}

	return iSearchResult;
}

//---------------------------------------------------------------------------

// This function actually calls VB LookupCall function

void CMixWCallbookMfcApp::Lookup()
{
	TRACE("CMixWCallbookMfcApp Lookup\n");

	if (m_DispDrv.m_lpDispatch==NULL)
	{
		TRACE("m_DispDrv.m_lpDispatch is NULL\n");
		iSearchResult = MCB_DATABASE_ERROR; // Too bad!
		return;
	}

	DISPPARAMS dispparamsArg;

	VARIANT vArgs[3];
	dispparamsArg.rgvarg = vArgs;

	dispparamsArg.rgvarg[2].vt = VT_BSTR;
	dispparamsArg.rgvarg[2].bstrVal = bsPath;

	dispparamsArg.rgvarg[1].vt = VT_BSTR;
	dispparamsArg.rgvarg[1].bstrVal = bsCallSign;

	dispparamsArg.rgvarg[0].vt = VT_BYREF|VT_BSTR;
	dispparamsArg.rgvarg[0].pbstrVal = &bsInfo;

	dispparamsArg.rgdispidNamedArgs = NULL;
	dispparamsArg.cArgs = 3;
	dispparamsArg.cNamedArgs = 0;


	VARIANT VarResult;

	int rc1 = m_DispDrv.m_lpDispatch->Invoke( 
			dispidLookupCall, IID_NULL, LOCALE_SYSTEM_DEFAULT,
			DISPATCH_METHOD, 
			&dispparamsArg,
			(VARIANT FAR*)(&VarResult),
			NULL,
			NULL );

	TRACE("Invoke: %i\n", rc1);
 
	TRACE("Result: %i\n", VarResult.lVal);

	iSearchResult =  VarResult.lVal; // Return result code	
}

//---------------------------------------------------------------------------

// Thread starter procedure, 

UINT CMixWCallbookMfcApp::CallBookThreadStarter( LPVOID pParam )
{
	return 
	((CMixWCallbookMfcApp*)pParam)->CallBookThreadProc(); // Call our function, pass "this"
}

//---------------------------------------------------------------------------

// Callbook thread

UINT CMixWCallbookMfcApp::CallBookThreadProc()
{
	PrepareActiveX(); // Initialize ActiveX and load VB DLL

	while (!bExitThread) // Until they tell us exit
	{
		if (bDoLookup)	// If they want to search,
		{
			Lookup();	// Search
			bDoLookup = FALSE;	// Signal that search completed
		}
		
		Sleep(50); // Little pause
	}

	UnprepareActiveX(); // Uninitialize ActiveX and unload VB DLL

	bExitThread = FALSE; // Signal that we are unloaded

	return 0; // Thread return code
}
